#ifndef LOCAL_HISTOGRAMS_H
#define LOCAL_HISTOGRAMS_H

#include <ImageStack/ImageStack.h>
#include <vector>

enum HistogramType {
	HISTOGRAM_VALUE = 1<<0,
	HISTOGRAM_INTEGRAL = 1<<1,
	HISTOGRAM_DERIVATIVE = 1<<2
};

class LocalHistograms {
public:
	LocalHistograms(ImageStack::Image &image, float sigmaIm = 10, float sigmaHist = 0.06, int nBins=20, HistogramType type = (HistogramType)(HISTOGRAM_VALUE|HISTOGRAM_INTEGRAL|HISTOGRAM_DERIVATIVE));
	
	~LocalHistograms() {
		delete value;
		delete integral;
		delete derivative;
	}
	
	ImageStack::Image localMode(int antialiasWidth = 1);
	ImageStack::Image globalMode(int antialiasWidth = 1);
	ImageStack::Image median(float target = 0.5, int antialiasWidth = 1);
private:
	ImageStack::Image *value, *integral, *derivative;
	ImageStack::Image &im;
	float imageSigma, histSigma;
	HistogramType histType;
	std::vector<float> bins;
	
	std::vector< std::pair<float,float> > getDisplacements(int antialiasWidth);
};

#endif
